import uuid

from stomp.frame.frame import Frame
from stomp.const import VALID_ACK_MODES
from stomp.const import SUBSCRIBE
from stomp import defaults
from stomp import headers
from stomp.utils import is_valid_channel


class Subscribe(Frame):

    @property
    def subscription_id(self):
        return self._subscription_id

    def __init__(self, destination, ack=defaults.ACK_MODE):
        if not is_valid_channel(destination):
            raise ValueError(
                "Invalid destination: {0}".format(destination))
        self._subscription_id = uuid.uuid1().hex
        Frame.__init__(self, SUBSCRIBE, headers={
            headers.SUBSCRIPTION_ID: self.subscription_id,
            headers.DESTINATION: destination,
            headers.ACK: ack
        })
