import errno


class AuthenticationError(Exception):
    pass


class InconsistentMessageBuffer(Exception):
    pass


class NoReceiptGiven(EnvironmentError):

    def __init__(self, msg, *args):
        EnvironmentError.__init__(errno.ETIMEDOUT, msg, *args)


class StompException(Exception):
    """Generic exception raised when the server returned an ``ERROR``
    frame.
    """

    def __init__(self, frame, message):
        self.frame = frame
        self.message = message

    def __repr__(self):
        return "{0}: {1}".format(
            type(self).__name__, self.message)

    def __str__(self):
        return self.message
